/**
* @file Arabic Unicode utilities
* @version 1.0.8
* @author Greg Borota
* @copyright (c) 2017 Greg Borota.
* @license MIT
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*/
!function(e,a){"object"==typeof exports&&"undefined"!=typeof module?a(exports,require("aramaic-mapper")):"function"==typeof define&&define.amd?define(["exports","aramaic-mapper"],a):a(e.arabicCodeUtil={},e.aramaicMapper)}(this,function(e,a){"use strict";var l,u=Object.freeze(Object.create(null,{alef:{value:"ا",enumerable:!0},beh:{value:"ب",enumerable:!0},jeem:{value:"ج",enumerable:!0},dal:{value:"د",enumerable:!0},heh:{value:"ه",enumerable:!0},waw:{value:"و",enumerable:!0},zain:{value:"ز",enumerable:!0},hah:{value:"ح",enumerable:!0},tah:{value:"ط",enumerable:!0},yeh:{value:"ي",enumerable:!0},kaf:{value:"ك",enumerable:!0},lam:{value:"ل",enumerable:!0},meem:{value:"م",enumerable:!0},noon:{value:"ن",enumerable:!0},seen:{value:"س",enumerable:!0},ain:{value:"ع",enumerable:!0},feh:{value:"ف",enumerable:!0},sad:{value:"ص",enumerable:!0},qaf:{value:"ق",enumerable:!0},reh:{value:"ر",enumerable:!0},sheen:{value:"ش",enumerable:!0},teh:{value:"ت",enumerable:!0},theh:{value:"ث",enumerable:!0},khah:{value:"خ",enumerable:!0},thal:{value:"ذ",enumerable:!0},dad:{value:"ض",enumerable:!0},zah:{value:"ظ",enumerable:!0},ghain:{value:"غ",enumerable:!0}})),n=Object.freeze([u.alef,u.beh,u.jeem,u.dal,u.heh,u.waw,u.zain,u.hah,u.tah,u.yeh,u.kaf,u.lam,u.meem,u.noon,u.seen,u.ain,u.feh,u.sad,u.qaf,u.reh,u.sheen,u.teh]),r=Object.freeze([u.theh,u.khah,u.thal,u.dad,u.zah,u.ghain,"ة","ء","آ","أ","ؤ","إ","ئ"]),m=Object.freeze(n.concat(r)),b=Object.freeze(Object.create(null,{fatha:{value:"َ",enumerable:!0},superscriptAlef:{value:"ٰ",enumerable:!0},kasra:{value:"ِ",enumerable:!0},damma:{value:"ُ",enumerable:!0},fathatan:{value:"ً",enumerable:!0},kasratan:{value:"ٍ",enumerable:!0},dammatan:{value:"ٌ",enumerable:!0}})),t=Object.freeze([b.fatha,b.superscriptAlef,b.kasra,b.damma,b.fathatan,b.kasratan,b.dammatan]),v=Object.freeze(Object.create(null,{shadda:{value:"ّ",enumerable:!0},sukun:{value:"ْ",enumerable:!0},maddahAbove:{value:"ٓ",enumerable:!0},hamzaAbove:{value:"ٔ",enumerable:!0},hamzaBelow:{value:"ٕ",enumerable:!0}})),h=Object.freeze([v.shadda,v.sukun,v.maddahAbove,v.hamzaAbove,v.hamzaBelow]),i=Object.freeze(["،","؛","؟","!"]),o=u,s=b,c=v,f=Object.freeze(Object.create(null,(l={},l[o.alef]={value:"a",enumerable:!0},l[o.beh]={value:"b",enumerable:!0},l[o.jeem]={value:"c",enumerable:!0},l[o.dal]={value:"d",enumerable:!0},l[o.heh]={value:"e",enumerable:!0},l[o.waw]={value:"f",enumerable:!0},l[o.zain]={value:"g",enumerable:!0},l[o.hah]={value:"h",enumerable:!0},l[o.tah]={value:"i",enumerable:!0},l[o.yeh]={value:"j",enumerable:!0},l[o.kaf]={value:"k",enumerable:!0},l[o.lam]={value:"l",enumerable:!0},l[o.meem]={value:"m",enumerable:!0},l[o.noon]={value:"n",enumerable:!0},l[o.seen]={value:"o",enumerable:!0},l[o.ain]={value:"p",enumerable:!0},l[o.feh]={value:"q",enumerable:!0},l[o.sad]={value:"r",enumerable:!0},l[o.qaf]={value:"s",enumerable:!0},l[o.reh]={value:"t",enumerable:!0},l[o.sheen]={value:"u",enumerable:!0},l[o.teh]={value:"v",enumerable:!0},l[o.theh]={value:"v",enumerable:!0},l[o.khah]={value:"k",enumerable:!0},l[o.thal]={value:"d",enumerable:!0},l[o.dad]={value:"w",enumerable:!0},l[o.zah]={value:"x",enumerable:!0},l[o.ghain]={value:"c",enumerable:!0},l.ة={value:"v",enumerable:!0},l.ء={value:"a",enumerable:!0},l.أ={value:"a",enumerable:!0},l.ؤ={value:"f",enumerable:!0},l.إ={value:"a",enumerable:!0},l.ئ={value:"j",enumerable:!0},l[s.fatha]={value:"y",enumerable:!0},l[s.fathatan]={value:"y",enumerable:!0},l[s.superscriptAlef]={value:"z",enumerable:!0},l.آ={value:"z",enumerable:!0},l[s.kasra]={value:"{",enumerable:!0},l[s.kasratan]={value:"{",enumerable:!0},l[s.damma]={value:"|",enumerable:!0},l[s.dammatan]={value:"|",enumerable:!0},l[c.shadda]={value:"",enumerable:!0},l[c.sukun]={value:",",enumerable:!0},l[c.maddahAbove]={value:"",enumerable:!0},l[c.hamzaAbove]={value:"",enumerable:!0},l[c.hamzaBelow]={value:"",enumerable:!0},l))),d=Object.freeze(t.concat(h)),z=function(e){return m.indexOf(e)>-1},j=function(e){return d.indexOf(e)>-1},p=a.hasDotting(j),O=a.clearDotting(j),k=a.getSort(f,z);e.consonantsByName=u,e.consonants=n,e.extraConsonants=r,e.allConsonants=m,e.vowelsByName=b,e.vowels=t,e.diacriticsByName=v,e.diacritics=h,e.punctuation=i,e.letterAsciiMap=f,e.dotting=d,e.isConsonant=z,e.isVowel=function(e){return t.indexOf(e)>-1},e.isDiacritic=function(e){return h.indexOf(e)>-1},e.isPunctuation=function(e){return i.indexOf(e)>-1},e.isDotting=j,e.isDotted=p,e.removeDotting=O,e.sort=k,Object.defineProperty(e,"__esModule",{value:!0})});
